Page MenuHomePhabricator

Pywikibot meetup wikimedia hackathon 2019 (usage and/or development workshop, issues and future discussion, other stuff to talk about)
Closed, ResolvedPublic

Description

Invitation

There are cca 1 000 Pywikibot bugs and tasks to do, it would be great for a hackaton, but it's too much of them. We can work on some project if there will be much interest. One project is already in plan: T186208 will be a challenge for me (as integration team is too busy to help).

Anyway I would rather do a training/skillsharing/workshop - personal help and knowledge. From basics/essentials to hard/deep-coded stuff. A look into the opportunities of the library; from using the scripts, through writing own scripts, up to the development. I can mentor patches for bugs driving you crazy.

Finally the meetup group is still growing to talk about any wonders coming to our minds, Pywikibot future and cooperations (T222608), issues and development, possibly some games (I have one: who can reach bug Traceback most quickly? :D I can do in 6 seconds with cfd.py, who can beat me? :D )

Meetup minutes

(https://etherpad.wikimedia.org/p/hackathon-2019-pywikibot)

First question: Wanted templates generator

Is it possible to get a generator of the list of Wanted:Templates/subtemplates in order to copy all the Wikipedia templates needed on a target wiki thanks to the script transfertbot.py?

Not yet, created a task for it: T223713

Introduction round
Issues with code reviews

It takes long to review patches. There are too many open issues and changesets. There should be a maximum of 5 patches open at a time.

Issues with scripts

Some are poorly written and should be removed from the framework.
Every script has header identifying script to server. With access to foundation logs one can identify unused scripts.

Perhaps the probably unused should be archived, marked as "archived in 2019". ( T223826 )
After a year without complaints about them being archived, they should be removed.

Also be aware of non-WM wikis, which can use the scripts we no longer need (interwiki.py)

Wikidata integrator

Another Python bot for Wikidata. Should Wikidata integrator and Pywikibot cooperate or merge?

Architecture complexity

It is not always clear how to use the framework correctly and understand the layers.

Docs (https://doc.wikimedia.org/pywikibot/)

Incomplete warning should be lowered (PS: done). Some methods still missing.

Too many patches to review

There are patches from 2015 (older were abandoned because of being old)
There are 1000+ tasks:

When is something worth upstreaming?

Just submit it and it can be improved later.

Is Gerrit apropriate for Pywikibot?

GitHub/Gitlab atracks more attention, are easy to use, but Gerrit from Wikimedia has online interface too and the tutorials are also great written.
Anyway Gerrit will be moved to Polygerrit this summer perhaps, this experience could be much better after that.

Do review all historic patches!
Pywikibot & Commons

There are too few scripts. Also there is missing a support for many API queries.
Perhaps tommorrow we should work together on Structured Data support ( T223820 ).

Python 2 deprecation ( T213287 )

We should not break the existing behavior, but many dependencies will do this soon. We should find a good compromise in a level of deprecation.
There are several possibilities:

  • Don't patch py2 patches anymore
  • above + don't write py2 compatible code anymore (breaking)
  • above + remove all py2 specific code (breaking)
  • ... (perhaps this should be further discussed) There were suggestions to fix only hard breaking changes and not soft breaking changes or the other way around as well.
    • @Xqt: Remarks from outside: These proposals are problematic due to syntax changes in Python 3 and new functionalities which can improve further developing (e.g. Enum, async, coroutine, Pathlib) You can't have the cake and eat it ;) Everyone can go back to the last tag supporting older Python releases on their own risk. Currently we activly propose to migrate to Python 3 in next few months til 2020. But we also can hold the current core release for a while and then mark it as read-only in a year or so. And deploy a next release PWB 4.0 likewise Requests does it with Requests III supporting Python 3.6+ only.
Our time is gone, thank all 10+ participants to join our meetup!

Details

Related Gerrit Patches:

Event Timeline

Dvorapa created this task.Apr 24 2019, 7:43 PM
Restricted Application added subscribers: pywikibot-bugs-list, Aklapper. · View Herald TranscriptApr 24 2019, 7:43 PM
Xqt added a subscriber: Xqt.Apr 25 2019, 3:44 AM
Xqt added a comment.Apr 25 2019, 3:53 AM

Good idea but I am not able to come. Probably I am able to be on irc. A hackathon is able to bring forward the project a bit. I remember the introducing i18n or the pwb wrapper. We can focus one some important issues..

Dvorapa added a comment.EditedApr 25 2019, 10:06 AM

As it is in Prague this year, I'll be there for a day or two. I would like to propagate Pywikibot. I can lead a project (e.g. to solve sysop dualism or to remove Python 2 support, etc.) or a workshop. What would be the best?

solve sysop dualism

I will also be there

Xqt added a subscriber: Multichill.Apr 26 2019, 2:33 PM

I would be interest in talking to the pwb devs there. Not sure if there is enough audience for a session, but I'm interested in meeting and talking to you guys if there is not a session.

Dvorapa added a comment.EditedApr 26 2019, 8:54 PM

I'll be there mainly for talking with people :) It just have been suggested by my friend from Czech Wikimedia to try a workshop

I will be at the Prague hackathon and I'm quite sure @Ladsgroup too. Not sure if @valhallasw is coming this year. At minimum we should do a meet up with people interested in Pywikibot.

If you create video/Pdf then please share with us here. It will be useful for others who will not attend the Wikimedia Hackathon.

At minimum we should do a meet up with people interested in Pywikibot.

Sure!

If you create video/Pdf then please share with us here. It will be useful for others who will not attend the Wikimedia Hackathon.

Please remind this once again, I'm definitely forgetting this (sorry for my bad memory)

Dvorapa added a comment.EditedMay 14 2019, 11:12 PM

I will be at the Prague hackathon and I'm quite sure @Ladsgroup too.

Amir? I need help from him with Appveyor!

At minimum we should do a meet up with people interested in Pywikibot.

Sure!

I'll be on hackaton just at Friday and Saturday, perhaps one of these two days we should meet??

Dvorapa renamed this task from Pywikibot usage and/or development workshop to Pywikibot meetup (usage and/or development workshop, issues and future discussion, other stuff to talk about).May 14 2019, 11:34 PM
Dvorapa updated the task description. (Show Details)

I will be at the Prague hackathon and I'm quite sure @Ladsgroup too. Not sure if @valhallasw is coming this year. At minimum we should do a meet up with people interested in Pywikibot.

Yup, let's meet and do things :)

Anyone at the bar?

Okay, large meeting tomorrow 14 or 15? Other? Suggestions?

Dvorapa added a comment.EditedMay 18 2019, 6:22 AM

At 3 PM then

You mean 3PM? Sure. Where though?

Computer room 2 3rd floor? (it's large, but empty at the tme)

k. I'll be there

I will be there too

This was re-scheduled to one of the project rooms. Since project rooms can't be reserved, can't tell which one. Anyway, the guy at computer room 02 will know which project rooms it is.

Chicocvenancio added a comment.EditedMay 18 2019, 12:58 PM

Where are the project rooms?
The project rooms are on the 4th floor.

I updated the Etherpad with my personal notes from the meetup, feel free to add anythng I've missed!

Change 511318 had a related patch set uploaded (by Dvorapa; owner: Dvorapa):
[pywikibot/core@master] [docs] Lower the warning in the docs

https://gerrit.wikimedia.org/r/511318

Dvorapa updated the task description. (Show Details)May 19 2019, 1:12 PM

Change 511318 merged by jenkins-bot:
[pywikibot/core@master] [docs] Lower the warning in the docs

https://gerrit.wikimedia.org/r/511318

I updated the Etherpad once again with links to tasks on Phabricator

@Dvorapa : Etherpads are far from permanent. When you're done, you should put the contents in this ticket, see for example T216260

@Multichill I see, sure. Yesterday I even didn't know what Etherpad is, that's why my own notes were added later there.

@Dvorapa: Did this session take place? If it did, please feel free to create any potential follow-up tasks and set the status of this task to "Resolved" via the Add Action...Change Status dropdown. Thanks a lot!

Dvorapa closed this task as Resolved.Jun 7 2019, 1:50 PM
Dvorapa claimed this task.

Follow-up tasks created already, marking as resolved then

Dvorapa updated the task description. (Show Details)Jun 7 2019, 2:10 PM
Multichill renamed this task from Pywikibot meetup (usage and/or development workshop, issues and future discussion, other stuff to talk about) to Pywikibot meetup wikimedia hackathon 2019 (usage and/or development workshop, issues and future discussion, other stuff to talk about).Aug 5 2019, 5:11 PM